SystemOrganization addCategory: #'Pier-Randomizer'!

PRWidget subclass: #PRRandomizer
	instanceVariableNames: 'candidates current'
	classVariableNames: 'NoChildrenFound'
	poolDictionaries: ''
	category: 'Pier-Randomizer'!

!PRRandomizer class methodsFor: 'accessing-descriptions' stamp: 'lr 4/10/2008 14:17'!
descriptionKeep
	^ MABooleanDescription new
		comment: 'Keep the same random child during the lifetime of a session';
		accessor: #keep;
		default: true;
		priority: 100;
		label: 'Keep';
		yourself! !

!PRRandomizer class methodsFor: 'initialization' stamp: 'lr 6/7/2007 23:28'!
initialize
	NoChildrenFound := PRPage named: 'unnamed'.
	NoChildrenFound
		contents: 'Please add children to this widget'! !

!PRRandomizer class methodsFor: 'testing' stamp: 'lr 6/7/2007 22:44'!
isAbstract
	^ false! !

!PRRandomizer class methodsFor: 'accessing' stamp: 'lr 6/7/2007 22:44'!
label
	^ 'Randomizer'! !

!PRRandomizer methodsFor: 'accessing' stamp: 'lr 9/12/2007 18:18'!
candidates
	"Answer the possible candidates to display."

	^ candidates ifNil: [ candidates := self structure enumerator contents ]! !

!PRRandomizer methodsFor: 'accessing' stamp: 'lr 9/12/2007 18:18'!
current
	"Answer the current structure to display."

	(current isNil or: [ (self read: #descriptionKeep) not ]) ifTrue: [
		current := self candidates isEmpty
			ifFalse: [ self candidates atRandom ]
			ifTrue: [ NoChildrenFound ] ].
	^ current! !

!PRRandomizer methodsFor: 'rendering' stamp: 'lr 6/7/2007 22:59'!
renderContentOn: html
	self context renderer visit: self current! !

!PRRandomizer methodsFor: 'accessing' stamp: 'lr 9/12/2007 18:18'!
structure
	"Answer the owning structure, the structure this component is defined at."

	^ self context componentDictionary keyAtValue: self ifAbsent: [ nil ]! !
PRRandomizer initialize!
